#line 1 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/AVR/StereoAmp_click_AVR.c"
#line 1 "c:/users/branislav.marton/desktop/projects/stereoamp_click/example/stereoamp.h"
#line 1 "c:/users/branislav.marton/documents/mikroelektronika/mikroc pro for avr/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 46 "c:/users/branislav.marton/desktop/projects/stereoamp_click/example/stereoamp.h"
char* gain_text[] = {
 "  -80dB",
 "  -54dB",
 "-40.5dB",
 "-34.5dB",
 "  -30dB",
 "  -27dB",
 "  -24dB",
 "  -21dB",
 "  -18dB",
 "  -15dB",
 "-13.5dB",
 "  -12dB",
 "-10.5dB",
 "   -9dB",
 " -7.5dB",
 "   -6dB",
 " -4.5dB",
 "   -3dB",
 " -1.5dB",
 "    0dB",
 "  1.5dB",
 "    3dB",
 "  4.5dB",
 "    6dB",
 "  7.5dB",
 "    9dB",
 " 10.5dB",
 "   12dB",
 " 13.5dB",
 "   15dB",
 " 16.5dB",
 "   18dB"
};
#line 18 "C:/Users/branislav.marton/Desktop/Projects/StereoAmp_click/example/AVR/StereoAmp_click_AVR.c"
sbit LCD_RS at PORTA2_bit;
sbit LCD_EN at PORTD6_bit;
sbit LCD_D4 at PORTC4_bit;
sbit LCD_D5 at PORTC5_bit;
sbit LCD_D6 at PORTC6_bit;
sbit LCD_D7 at PORTC7_bit;

sbit LCD_RS_Direction at DDA2_bit;
sbit LCD_EN_Direction at DDD6_bit;
sbit LCD_D4_Direction at DDC4_bit;
sbit LCD_D5_Direction at DDC5_bit;
sbit LCD_D6_Direction at DDC6_bit;
sbit LCD_D7_Direction at DDC7_bit;



uint8_t volume_control = 0;

uint8_t volume_temp = 0;

const char custom_char_1[] = {16,16,16,16,16,16,16,16};
const char custom_char_2[] = {24,24,24,24,24,24,24,24};
const char custom_char_3[] = {28,28,28,28,28,28,28,28};
const char custom_char_4[] = {30,30,30,30,30,30,30,30};
const char custom_char_5[] = {31,31,31,31,31,31,31,31};

void Generate_Custom_Chars() {
 char i;
 Lcd_Cmd(64);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_1[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(72);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_2[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(80);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_3[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(88);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_4[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);

 Lcd_Cmd(96);
 for (i = 0; i<=7; i++) Lcd_Chr_CP(custom_char_5[i]);
 Lcd_Cmd(_LCD_RETURN_HOME);
}


uint8_t Read_Volume_Step() {
 uint16_t adc_value = ADC_Read(5);


 adc_value &= 0x03FF;
 return adc_value / 32;
}

void Draw_Bar(unsigned row_pos, unsigned char_pos, unsigned value) {
 unsigned i;
 uint8_t white_char = 0;

 for(i = 0; i < 7; i++) {
 if (value / ((i + 1) * 5) > 0) {
 Lcd_Chr(row_pos, char_pos + i, 4);
 } else if (white_char) {
 Lcd_Chr(row_pos, char_pos + i, ' ');
 } else {
 Lcd_Chr(row_pos, char_pos + i, value % 5);
 white_char = 1;
 }
 }
}

void Write_Amp_Reg(uint8_t amp_addr, uint8_t reg_addr, uint8_t reg_data) {
 delay_ms(100);
 TWI_Start();
 TWI_Write(amp_addr);
 TWI_Write( (reg_addr &  0b11100000 ) | (reg_data &  0b00011111 ) );
 TWI_Stop();
}


void Init() {

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Generate_Custom_Chars();

 volume_control = Read_Volume_Step();
 Draw_Bar(1, 10, volume_control);
 Lcd_Out(1, 2, gain_text[volume_control]);




 DDC0_bit = 1;
 DDC1_bit = 1;

 PORTC0_bit = 1;
 PORTC1_bit = 1;

 Delay_ms(300);

 PORTC0_bit = 0;
 PORTC1_bit = 0;

 Delay_ms(300);

 TWI_Init( 200000 );
 Delay_ms(800);


 Write_Amp_Reg( 0XF8 ,  0b00000000 ,  0b00010000  |  0b00000100 );
 Write_Amp_Reg( 0XFA ,  0b00000000 ,  0b00010000  |  0b00000100 );


 Write_Amp_Reg( 0XF8 ,  0b01100000 , volume_control);
 Write_Amp_Reg( 0XFA ,  0b01100000 , volume_control);


 Write_Amp_Reg( 0XF8 ,  0b01000000 ,  0b00000010  |  0b00000001  |  0b00000100  |  0b00001000  |  0b00010000 );
 Write_Amp_Reg( 0XFA ,  0b01000000 ,  0b00000010  |  0b00000001  |  0b00000100  |  0b00001000  |  0b00010000 );


 Write_Amp_Reg( 0XF8 ,  0b00100000 ,  0b00010000  |  0b00000100  |  0b00000010 );
 Write_Amp_Reg( 0XFA ,  0b00100000 ,  0b00010000  |  0b00000100  |  0b00000010 );
}


void Set_Volume(char amp_addr, char value) {
 Write_Amp_Reg(amp_addr,  0b01100000 , value);
}


void main() {
 Init();

 while(1) {
 volume_temp = Read_Volume_Step();

 if(volume_temp != volume_control) {
 volume_control = volume_temp;

 Draw_Bar(1, 10, volume_control);
 Lcd_Out(1, 2, gain_text[volume_control]);

 Set_Volume( 0XF8 , volume_control);
 Set_Volume( 0XFA , volume_control);
 }

 Delay_ms( 5 );
 }
}
